%if %{mdvver} < 201410
%define _tmpfilesdir %{_prefix}/lib/tmpfiles.d/
%endif

# {_exec_prefix}/lib/cups is correct, even on x86_64.
# It is not used for shared objects but for executables.
# It's more of a libexec-style ({_libexecdir}) usage,
# but we use lib for compatibility with 3rd party drivers (at upstream request).
%global cups_serverbin %{_exec_prefix}/lib/cups

# Turning this on lets CUPS to be built in debug mode (with debugger symbols)
%define debug 1
%define enable_check 0

%bcond_with bootstrap

%if %{without bootstrap}
%bcond_without systemd
%endif

%bcond_with poll_ppd_base

%{?build_selinux}%{?!build_selinux:%bcond_with selinux}

Summary:	Common Unix Printing System - Server package
Name:		cups
Version:	1.7.5
Release:	18
License:	GPLv2+ and LGPLv2+
Group:		System/Printing
Url:		http://www.cups.org
#Source0:	ftp://ftp.easysw.com/pub/cups/%{version}/%{name}-%{version}-source.tar.bz2
Source0:	http://www.cups.org/software/%{version}/%{name}-%{version}-source.tar.bz2
# Small C program to get list of all installed PPD files
Source1:	poll_ppd_base.c
# Small C program to list the printer-specific options of a particular printer
# fails to build now
Source2:	lphelp.c
# socket unit for cups-lpd service
Source3:	cups-lpd.socket
# cups-lpd service unit configuration
Source4:	cups-lpd@.service
# Backend for NCP protocol
Source7:	ncp.backend
# Perl script for automatic configuration of CUPS, especially access
# restrictions and broadcasting
Source9:	cups.logrotate
# Backend filter for nprint (Novell client) from Mark Horn
# (mark@hornclan.com)
Source11:	http://www.hornclan.com/~mark/cups/nprint.2002011801
# AppleTalk/netatalk backend for CUPS
Source12:	http://www.oeh.uni-linz.ac.at/~rupi/pap/pap-backend.tar.bz2
Source13:	http://www.oeh.uni-linz.ac.at/~rupi/pap/pap-docu.pdf.bz2
Source14:	http://www.linuxprinting.org/download/printing/photo_print
Source15:	http://printing.kde.org/downloads/pdfdistiller
Source16:	cjktexttops
Source17:	correctcupsconfig
# Nice level for now. bug #16387
Source18:	cups.sysconfig
# udev rules for setting symlinks needed if the usblp module is loaded
Source19:	10-cups_device_links.rules
# Udev rules for setting properly rights and groups
Source20:	10-cups_device_usb.rules

### FEDORA PATCHES ###

Patch1:		cups-no-gzip-man.patch
Patch2:		cups-system-auth.patch
Patch3:		cups-multilib.patch
Patch5:		cups-banners.patch
Patch6:		cups-serverbin-compat.patch
Patch7:		cups-no-export-ssllibs.patch
Patch8:		cups-direct-usb.patch
Patch9:		cups-lpr-help.patch
Patch10:	cups-peercred.patch
Patch11:	cups-pid.patch
Patch12:	cups-eggcups.patch
Patch13:	cups-driverd-timeout.patch
Patch14:	cups-strict-ppd-line-length.patch
Patch15:	cups-logrotate.patch
Patch16:	cups-usb-paperout.patch
Patch17:	cups-res_init.patch
Patch18:	cups-filter-debug.patch
Patch19:	cups-uri-compat.patch
Patch20:	cups-str3382.patch
Patch21:	cups-0755.patch
Patch22:	cups-hp-deviceid-oid.patch
Patch23:	cups-dnssd-deviceid.patch
Patch24:	cups-ricoh-deviceid-oid.patch
Patch25:	cups-systemd-socket.patch
Patch26:	cups-lpd-manpage.patch
Patch27:	cups-avahi-address.patch
Patch29:	cups-enum-all.patch
Patch31:	cups-dymo-deviceid.patch
Patch32:	cups-freebind.patch
Patch33:	cups-no-gcry.patch
Patch34:	cups-libusb-quirks.patch
Patch35:	cups-use-ipp1.1.patch
Patch36:	cups-avahi-no-threaded.patch
Patch38:	cups-journal.patch
Patch39:	cups-ipp-multifile.patch
Patch41:	cups-web-devices-timeout.patch
Patch43:	cups-final-content-type.patch
Patch46:	cups-synconclose.patch
Patch47:	cups-str4551-CVE-2014-9679.patch
Patch48:	str4609-prevent-privilege-escalation-through-dynamic-linker.patch

#ROSA patches

#markup patchset
# Patch100:	cups-1.7.5-lspp.patch
# Patch101:	cups-1.7.5-pstopstagged.patch
# Patch102:	cups-1.7.5-mandatory.patch



BuildRequires:	php-cli
BuildRequires:	xinetd
BuildRequires:	xdg-utils
BuildRequires:	acl-devel
BuildRequires:	jpeg-devel
BuildRequires:	krb5-devel
BuildRequires:	libldap-devel
BuildRequires:	openslp-devel
BuildRequires:	pam-devel
BuildRequires:	php-devel
BuildRequires:	tiff-devel
BuildRequires:	pkgconfig(avahi-compat-libdns_sd)
BuildRequires:	pkgconfig(dbus-1) >= 0.50
BuildRequires:	pkgconfig(gnutls) >= 3.0
BuildRequires:	pkgconfig(libcrypto)
BuildRequires:	pkgconfig(libpng)
BuildRequires:	pkgconfig(libssl)
BuildRequires:	pkgconfig(libusb) < 1.0
BuildRequires:	pkgconfig(libusb-1.0)
BuildRequires:	pkgconfig(zlib)
%if !%{with bootstrap}
BuildRequires:	poppler
%if %{with systemd}
BuildRequires:	systemd-units
BuildRequires:	pkgconfig(libsystemd-daemon)
BuildRequires:	pkgconfig(libsystemd-journal)
BuildRequires:	pkgconfig(libsystemd-login)
BuildRequires:	pkgconfig(systemd)
%endif
%endif
%if %{with selinux}
BuildRequires:	audit-devel
BuildRequires:	selinux-devel
BuildRequires:	hffilter
Requires:	hffilter
%endif

Requires:	%{name}-common >= %{EVRD}
# We ship udev rules which use setfacl
Requires:	acl
Requires:	cups-filters
# Make sure we have some filters for converting to raster format
Requires:	ghostscript
Requires:	net-tools
%if !%{with bootstrap}
Requires:	poppler
Suggests:	avahi
%endif
Requires:	printer-testpages
# Take care that device files are created with correct permissions
Requires:	udev
Requires:	update-alternatives
# For desktop menus
Requires:	xdg-utils
# Requires /etc/tmpfiles.d (bug #656566)
Requires:	systemd
Requires(post,preun,postun):	systemd
Requires(post,preun):	rpm-helper

%rename cupsddk-drivers

%description
The Common Unix Printing System provides a portable printing layer for
UNIX(TM) operating systems. It has been developed by Easy Software Products
to promote a standard printing solution for all UNIX vendors and users.
CUPS provides the System V and Berkeley command-line interfaces.
This is the main package needed for CUPS servers (machines where a
printer is connected to or which host a queue for a network printer).
It can also be used on CUPS clients so that they simply pick up
broadcasted printer information from other CUPS servers and do not
need to be assigned to a specific CUPS server by an
%{_sysconfdir}/cups/client.conf file.

%files
%doc *.txt
%config(noreplace) %attr(-,root,lp) %{_sysconfdir}/cups/cupsd.conf
%config(noreplace) %attr(-,root,root) %_sysconfdir/cups/cups-files.conf
%config(noreplace) %attr(-,root,root) %{_sysconfdir}/sysconfig/cups
%ghost %config(noreplace) %{_sysconfdir}/cups/printers.conf
%ghost %config(noreplace) %{_sysconfdir}/cups/classes.conf
%attr(-,root,sys) %{_sysconfdir}/cups/cupsd.conf.default
%config(noreplace) %attr(-,root,lp) %{_sysconfdir}/cups/interfaces
#%config(noreplace) %attr(644,root,lp) %{_sysconfdir}/cups/mime.convs
#%config(noreplace) %attr(644,root,lp) %{_sysconfdir}/cups/mime.types
%config(noreplace) %attr(-,root,lp) %{_sysconfdir}/cups/ppd
%config(noreplace) %attr(-,root,lp) %{_sysconfdir}/cups/ssl
%config(noreplace) %attr(-,root,lp) %{_sysconfdir}/cups/snmp.conf
%config(noreplace) %attr(-,root,lp) %{_sysconfdir}/dbus*/system.d/cups.conf
%{_tmpfilesdir}/cups.conf
%{_tmpfilesdir}/cups-lp.conf
%config(noreplace) %{_sysconfdir}/pam.d/cups
%config(noreplace) %{_sysconfdir}/logrotate.d/cups
%attr(644,root,root) %config(noreplace) %{_sysconfdir}/xinetd.d/cups-lpd
%_sysconfdir/udev/rules.d/*
%dir %{_prefix}/lib/cups
%{_prefix}/lib/cups/cgi-bin
%{_prefix}/lib/cups/daemon
%{_prefix}/lib/cups/notifier
%{_prefix}/lib/cups/filter
%{_prefix}/lib/cups/monitor
%dir %{_prefix}/lib/cups/backend
%{_prefix}/lib/cups/backend/dnssd
%{_prefix}/lib/cups/backend/http
%{_prefix}/lib/cups/backend/https
%{_prefix}/lib/cups/backend/ipp
%{_prefix}/lib/cups/backend/ipps
%{_prefix}/lib/cups/backend/lpd
%{_prefix}/lib/cups/backend/mdns
%{_prefix}/lib/cups/backend/nprint
%{_prefix}/lib/cups/backend/pap
#{_prefix}/lib/cups/backend/parallel
%{_prefix}/lib/cups/backend/ncp
#%{_prefix}/lib/cups/backend/scsi
%{_prefix}/lib/cups/backend/snmp
%{_prefix}/lib/cups/backend/socket
%{_prefix}/lib/cups/backend/usb
%{_prefix}/lib/cups/backend/pdf
%dir %{_prefix}/lib/cups/driver
%{_datadir}/cups
%attr(0755,root,lp) %{_var}/log/cups
# Set ownerships of spool directory which is normally done by 'make install'
# Because RPM does 'make install' as normal user, this has to be done here
%dir %attr(0710,root,lp) %{_var}/spool/cups
%dir %attr(01770,root,lp) %{_var}/spool/cups/tmp
%dir %attr(775,root,lp) %{_var}/cache/cups
# Bug #28383 dirs
%dir %{_datadir}/ppd
%dir %{_libdir}/printdriver
# Desktop icons
%{_datadir}/applications/*
%{_datadir}/icons/hicolor/*/apps/cups.png
%ifarch x86_64
# Compatibility link, will be removed soon
%{_libdir}/cups
%endif
%if %{with systemd}
/lib/systemd/system/cups.*
/lib/systemd/system/cups-*
%endif

%pre
%ifarch x86_64
# Fix /usr/lib/cups directory, so that updates can be done
if [ -d %{_libdir}/cups ] && ! [ -h %{_libdir}/cups ]; then
    if [ -h %{_prefix}/lib/cups ]; then
        rm -f %{_prefix}/lib/cups
	mv %{_libdir}/cups %{_prefix}/lib/cups
    else
	mv %{_libdir}/cups %{_libdir}/cups.rpmsave
	#echo 'Moved %{_libdir}/cups to %{_libdir}/cups.rpmsave' 1>&2
    fi
fi
%endif
%_pre_groupadd lpadmin

%post
# Make sure group ownerships are correct
chgrp -R lp %{_sysconfdir}/cups %{_var}/*/cups

# We can't enforce this. Bug #35993
for d in /opt/share/ppd /opt/lib/printdriver /usr/local/share/ppd /usr/local/lib/printdriver
do
  [ ! -e $d ] && mkdir -p $d || :
done
# End of 28383

# Let CUPS daemon be automatically started at boot time
%_post_service cups

# Remove old-style certs directory; new-style is /var/run
# (see bug #194581 for why this is necessary).
/bin/rm -rf %{_sysconfdir}/cups/certs

%preun
# Let CUPS daemon not be automatically started at boot time any more
%_preun_service cups

%postun
%_postun_groupdel lpadmin

#----------------------------------------------------------------------------

%package common
Summary:	Common Unix Printing System - Common stuff
License:	GPLv2+
Group:		System/Printing
Requires:	net-tools
Requires(post,preun):	update-alternatives
# To satisfy LSB/FHS
Provides:	lpddaemon

%description common
The Common Unix Printing System provides a portable printing layer for
UNIX(TM) operating systems. It contains the command line utilities for
printing and administration (lpr, lpq, lprm, lpadmin, lpc, ...), man
pages, locales, and a sample configuration file for daemon-less CUPS
clients (%{_sysconfdir}/cups/client.conf).

This package you need for both CUPS clients and servers.

%files common
%dir %config(noreplace) %attr(-,lp,lp) %{_sysconfdir}/cups
%ghost %config(noreplace) %attr(-,lp,lp) %{_sysconfdir}/cups/client.conf
%{_sbindir}/*
%{_bindir}/*cups
%{_bindir}/ippfind
%{_bindir}/ipptool
#%{_bindir}/lphelp
%{_bindir}/lpoptions
%attr(6755,root,lp) %{_bindir}/lppasswd
%{_bindir}/photo_print
#{_bindir}/poll_ppd_base
%{_bindir}/ppdc
%{_bindir}/ppdhtml
%{_bindir}/ppdi
%{_bindir}/ppdmerge
%{_bindir}/ppdpo
%{_bindir}/cupstestppd
%{_bindir}/cupstestdsc
%{_bindir}/enable
%{_bindir}/disable
%{_datadir}/locale/*/*.po
%{_mandir}/man?/*

%post common
# The lpc updates-alternative links were not correctly set in older CUPS
# packages, therefore remove the entry before making a new one when updating
%{_sbindir}/update-alternatives --remove lpc %{_sbindir}/lpc-cups || :
# Set up update-alternatives entries
%{_sbindir}/update-alternatives --install %{_bindir}/lpr lpr %{_bindir}/lpr-cups 10 --slave %{_mandir}/man1/lpr.1%{_extension} lpr.1%{_extension} %{_mandir}/man1/lpr-cups.1%{_extension}
%{_sbindir}/update-alternatives --install %{_bindir}/lpq lpq %{_bindir}/lpq-cups 10 --slave %{_mandir}/man1/lpq.1%{_extension} lpq.1%{_extension} %{_mandir}/man1/lpq-cups.1%{_extension}
%{_sbindir}/update-alternatives --install %{_bindir}/lprm lprm %{_bindir}/lprm-cups 10 --slave %{_mandir}/man1/lprm.1%{_extension} lprm.1%{_extension} %{_mandir}/man1/lprm-cups.1%{_extension}
%{_sbindir}/update-alternatives --install %{_bindir}/lp lp %{_bindir}/lp-cups 10 --slave %{_mandir}/man1/lp.1%{_extension} lp.1%{_extension} %{_mandir}/man1/lp-cups.1%{_extension}
%{_sbindir}/update-alternatives --install %{_bindir}/cancel cancel %{_bindir}/cancel-cups 10 --slave %{_mandir}/man1/cancel.1%{_extension} cancel.1%{_extension} %{_mandir}/man1/cancel-cups.1%{_extension}
%{_sbindir}/update-alternatives --install %{_bindir}/lpstat lpstat %{_bindir}/lpstat-cups 10 --slave %{_mandir}/man1/lpstat.1%{_extension} lpstat.1%{_extension} %{_mandir}/man1/lpstat-cups.1%{_extension}
%{_sbindir}/update-alternatives --install %{_sbindir}/accept accept %{_sbindir}/accept-cups 10 --slave %{_mandir}/man8/accept.8%{_extension} accept.8%{_extension} %{_mandir}/man8/accept-cups.8%{_extension}
%{_sbindir}/update-alternatives --install %{_sbindir}/disable disable %{_sbindir}/disable-cups 10 --slave %{_mandir}/man8/disable.8%{_extension} disable.8%{_extension} %{_mandir}/man8/disable-cups.8%{_extension}
%{_sbindir}/update-alternatives --install %{_sbindir}/enable enable %{_sbindir}/enable-cups 10 --slave %{_mandir}/man8/enable.8%{_extension} enable.8%{_extension} %{_mandir}/man8/enable-cups.8%{_extension}
%{_sbindir}/update-alternatives --install %{_sbindir}/lpc lpc %{_sbindir}/lpc-cups 10 --slave %{_mandir}/man8/lpc.8%{_extension} lpc.8%{_extension} %{_mandir}/man8/lpc-cups.8%{_extension}
%{_sbindir}/update-alternatives --install %{_sbindir}/lpmove lpmove %{_sbindir}/lpmove-cups 10 --slave %{_mandir}/man8/lpmove.8%{_extension} lpmove.8%{_extension} %{_mandir}/man8/lpmove-cups.8%{_extension}
%{_sbindir}/update-alternatives --install %{_sbindir}/reject reject %{_sbindir}/reject-cups 10 --slave %{_mandir}/man8/reject.8%{_extension} reject.8%{_extension} %{_mandir}/man8/reject-cups.8%{_extension}

rm -f %{_localstatedir}/cache/cups/*.ipp %{_localstatedir}/cache/cups/*.cache

# Deal with config migration due to CVE-2012-5519 (STR #4223)
IN=%{_sysconfdir}/cups/cupsd.conf
OUT=%{_sysconfdir}/cups/cups-files.conf
copiedany=no
for keyword in AccessLog CacheDir ConfigFilePerm	\
    DataDir DocumentRoot ErrorLog FatalErrors		\
    FileDevice FontPath Group LogFilePerm		\
    LPDConfigFile PageLog Printcap PrintcapFormat	\
    RemoteRoot RequestRoot ServerBin ServerCertificate	\
    ServerKey ServerRoot SMBConfigFile StateDir		\
    SystemGroup SystemGroupAuthKey TempDir User; do
    if ! [ -f "$IN" ] || ! /bin/grep -iq ^$keyword "$IN"; then continue; fi
    copy=yes
    if /bin/grep -iq ^$keyword "$OUT"; then
	if [ "`/bin/grep -i ^$keyword "$IN"`" ==	\
	     "`/bin/grep -i ^$keyword "$OUT"`" ]; then
	    copy=no
	else
	    /bin/sed -i -e "s,^$keyword,#$keyword,i" "$OUT" || :
	fi
    fi
    if [ "$copy" == "yes" ]; then
	if [ "$copiedany" == "no" ]; then
	    (cat >> "$OUT" <<EOF

# Settings automatically moved from cupsd.conf by RPM package:
EOF
	    ) || :
	fi

	(/bin/grep -i ^$keyword "$IN" >> "$OUT") || :
	copiedany=yes
    fi

    /bin/sed -i -e "s,^$keyword,#$keyword,i" "$IN" || :
done

exit 0

%preun common
if [ "$1" = 0 ]; then
# Remove update-alternatives entries
  %{_sbindir}/update-alternatives --remove lpr %{_bindir}/lpr-cups
  %{_sbindir}/update-alternatives --remove lpq %{_bindir}/lpq-cups
  %{_sbindir}/update-alternatives --remove lprm %{_bindir}/lprm-cups
  %{_sbindir}/update-alternatives --remove lp %{_bindir}/lp-cups
  %{_sbindir}/update-alternatives --remove cancel %{_bindir}/cancel-cups
  %{_sbindir}/update-alternatives --remove lpstat %{_bindir}/lpstat-cups
  %{_sbindir}/update-alternatives --remove accept %{_sbindir}/accept-cups
  %{_sbindir}/update-alternatives --remove disable %{_sbindir}/disable-cups
  %{_sbindir}/update-alternatives --remove enable %{_sbindir}/enable-cups
  %{_sbindir}/update-alternatives --remove lpc %{_sbindir}/lpc-cups
  %{_sbindir}/update-alternatives --remove lpmove %{_sbindir}/lpmove-cups
  %{_sbindir}/update-alternatives --remove reject %{_sbindir}/reject-cups
fi

#----------------------------------------------------------------------------

%define cupsmajor 2
%define libcups %mklibname cups %{cupsmajor}

%package -n %{libcups}
Summary:	Common Unix Printing System - CUPS shared library
License:	LGPLv2+
Group:		System/Libraries
Obsoletes:	%{_lib}cups3 < 1.6.1-2

%description -n %{libcups}
Common Unix Printing System - CUPS shared library.

%files -n %{libcups}
%{_libdir}/libcups.so.%{cupsmajor}*

#----------------------------------------------------------------------------

%define cupscgimajor 1
%define libcupscgi %mklibname cupscgi %{cupscgimajor}

%package -n %{libcupscgi}
Summary:	Common Unix Printing System - CUPSCGI shared library
License:	LGPLv2
Group:		System/Libraries
Conflicts:	%{libcups} < 1.6.1-2

%description -n %{libcupscgi}
Common Unix Printing System - CUPSCGI shared library.

%files -n %{libcupscgi}
%{_libdir}/libcupscgi.so.%{cupscgimajor}*

#----------------------------------------------------------------------------

%define cupsimagemajor 2
%define libcupsimage %mklibname cupsimage %{cupsimagemajor}

%package -n %{libcupsimage}
Summary:	Common Unix Printing System - CUPSimage shared library
License:	LGPLv2
Group:		System/Libraries
Conflicts:	%{libcups} < 1.6.1-2

%description -n %{libcupsimage}
Common Unix Printing System - CUPSimage shared library.

%files -n %{libcupsimage}
%{_libdir}/libcupsimage.so.%{cupsimagemajor}*

#----------------------------------------------------------------------------

%define cupsmimemajor 1
%define libcupsmime %mklibname cupsmime %{cupsmimemajor}

%package -n %{libcupsmime}
Summary:	Common Unix Printing System - CUPSMIME shared library
License:	LGPLv2
Group:		System/Libraries
Conflicts:	%{libcups} < 1.6.1-2

%description -n %{libcupsmime}
Common Unix Printing System - CUPSMIME shared library.

%files -n %{libcupsmime}
%{_libdir}/libcupsmime.so.%{cupsmimemajor}*

#----------------------------------------------------------------------------

%define cupsppdcmajor 1
%define libcupsppdc %mklibname cupsppdc %{cupsppdcmajor}

%package -n %{libcupsppdc}
Summary:	Common Unix Printing System - CUPSPPDC shared library
License:	LGPLv2
Group:		System/Libraries
Conflicts:	%{libcups} < 1.6.1-2

%description -n %{libcupsppdc}
Common Unix Printing System - CUPSPPDC shared library.

%files -n %{libcupsppdc}
%{_libdir}/libcupsppdc.so.%{cupsppdcmajor}*

#----------------------------------------------------------------------------

%define devname %mklibname %{name} -d

%package -n %{devname}
Summary:	Common Unix Printing System - development files
License:	LGPLv2+
Group:		Development/C
Requires:	%{libcups} = %{EVRD}
Requires:	%{libcupscgi} = %{EVRD}
Requires:	%{libcupsimage} = %{EVRD}
Requires:	%{libcupsmime} = %{EVRD}
Requires:	%{libcupsppdc} = %{EVRD}
Provides:	cups-devel = %{EVRD}

%description -n %{devname}
Common Unix Printing System - development files.

%files -n %{devname}
%dir %{_includedir}/cups
%{_includedir}/cups/*
%dir %{multiarch_includedir}/cups
%{multiarch_includedir}/cups/*
%{_libdir}/*.so
%{_bindir}/cups-config

#----------------------------------------------------------------------------

%prep
%setup -q
%apply_patches

# Revert lspp patches if markups disabled
# %if %{without selinux}
# %patch102 -p1 -R
# %patch101 -p1 -R -b .pstopstagged
# %patch100 -p1 -R -b .lspp
# %endif


# Set CUPS users and groups
perl -p -i -e 's:(SystemGroup\s+.*)$:$1\nGroup sys\nUser lp:' conf/cupsd.conf.in

# Let local printers be broadcasted in the local network(s)
perl -p -i -e 's:(Listen\s+)localhost:$1*:' conf/cupsd.conf.in
perl -p -i -e 's:(Browsing\s+On):$1\nBrowseAddress \@LOCAL:' conf/cupsd.conf.in
perl -p -i -e 's:(<Location\s+/\s*>):$1\n  Allow \@LOCAL:' conf/cupsd.conf.in

# Allow remote administration in local network (connections are encrypted,
# so no security problem)
perl -p -i -e 's:(<Location\s+/admin(|/conf)\s*>):$1\n  Allow \@LOCAL:' conf/cupsd.conf.in

# Replace the PAM configuration file
cat << EOF > scheduler/cups.pam
auth	include	system-auth
account	include	system-auth
EOF
cp -f scheduler/cups.pam conf/pam.std.in

# Let the Makefiles not trying to set file ownerships
perl -p -i -e "s/ -o \\$.CUPS_USER.//" scheduler/Makefile
perl -p -i -e "s/ -g \\$.CUPS_GROUP.//" scheduler/Makefile
perl -p -i -e "s/ -o \\$.CUPS_USER.//" systemv/Makefile
perl -p -i -e "s/ -g \\$.CUPS_GROUP.//" systemv/Makefile

sed -i -e '1iMaxLogSize 0' conf/cupsd.conf.in

f=CREDITS.txt
mv "$f" "$f"~
iconv -f MACINTOSH -t UTF-8 "$f"~ > "$f"
rm "$f"~

# Let's look at the compilation command lines.
perl -p -i -e "s,^.SILENT:,," Makedefs.in

# Load additional tools
cp %{SOURCE1} poll_ppd_base.c
cp %{SOURCE2} lphelp.c
# Load nprint backend
cp %{SOURCE11} nprint
# Load AppleTalk "pap" backend
%setup -q -T -D -a 12 -n %{name}-%{version}
# Load the "pap" documentation
bzcat %{SOURCE13} > pap-docu.pdf
# Load the "photo_print" utility
cp %{SOURCE14} photo_print
# Load the "pdfdistiller" utility
cp %{SOURCE15} pdf
# Load the "cjktexttops" filter
cp %{SOURCE16} cjktexttops

%build
# needed by additional SOURCES
aclocal
autoconf
# for the PHP module
%define _disable_ld_no_undefined 1
#setup_compile_flags
# cups uses $DSOFLAGS instead of $LDFLAGS for shared libs
export DSOFLAGS="$LDFLAGS"
%configure2_5x \
%if %{with selinux}
	--enable-lspp \
	--with-hffilter=hffilter \
%endif
	--enable-avahi \
%if %{debug}
	--enable-debug=yes \
%endif
	--with-cupsd-file-perm=0755 \
	--with-log-file-perm=0600 \
	--disable-libpaper \
	--enable-raw-printing \
	--enable-ssl \
	--disable-static \
	--with-cups-group=lp \
	--with-cups-user=lp \
	--with-docdir=%{_datadir}/cups/doc \
	--with-icondir=%{_datadir}/icons \
	--with-system-groups="lpadmin root" \
	--with-php=%{_bindir}/php \
	--enable-avahi \
	--enable-webif \
	--enable-relro

%if %{debug}
# Remove "-s" (stripping) option from "install" command used for binaries
# by "make install"
perl -p -i -e 's:^(\s*INSTALL_BIN\s*=.*)-s:$1:' Makedefs
%endif

# Remove hardcoded "chgrp" from Makefiles
perl -p -i -e 's/chgrp/:/' Makefile */Makefile
%make

# Compile additional tools
%if %{with poll_ppd_base}
gcc %{optflags} %{ldflags} -opoll_ppd_base -I. -I./cups poll_ppd_base.c -L./cups -lcups
%endif

%install
make install \
	BUILDROOT=%{buildroot} \
	DOCDIR=%{buildroot}%{_datadir}/cups/doc \
	CHOWN=":" CHGRP=":" STRIP="$STRIP" \
	LOGDIR=%{buildroot}%{_var}/log/cups \
	REQUESTS=%{buildroot}%{_var}/spool/cups \
	STATEDIR=%{buildroot}%{_var}/run/cups

rm -f %{buildroot}%{_libdir}/lib*.la
# Make a directory for PPD generators
mkdir -p %{buildroot}%{_prefix}/lib/cups/driver

# Make a directory for the SSL files
mkdir -p %{buildroot}%{_sysconfdir}/cups/ssl

# Make a directory for logrotate configuration
mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d

# Install nprint backend
install -m 755 nprint %{buildroot}%{_prefix}/lib/cups/backend/

# Install AppleTalk backend
install -m 755 pap-backend/pap %{buildroot}%{_prefix}/lib/cups/backend/
install -m 644 pap-docu.pdf %{buildroot}%{_datadir}/%{name}/doc

# Link dnssd backend as mdns backend
(cd %{buildroot}%{cups_serverbin}/backend && ln -s dnssd mdns)

# Install "photo_print"
install -m 755 photo_print %{buildroot}%{_bindir}

# Install "pdfdistiller"
install -m 755 pdf %{buildroot}%{_prefix}/lib/cups/backend/

# Install "cjktexttops"
install -m 755 cjktexttops %{buildroot}%{_prefix}/lib/cups/filter/

# Install logrotate configuration
install -c -m 644 %{SOURCE9} %{buildroot}%{_sysconfdir}/logrotate.d/cups

# Install additional tools
%if %{with poll_ppd_base}
install -m 755 poll_ppd_base %{buildroot}%{_bindir}
%endif

# Set link to test page in /usr/share/printer-testpages
ln -s %{_datadir}/printer-testpages/testprint.ps %{buildroot}%{_datadir}/cups/data/testprint-mdv.ps

# Install startup script
install -d %{buildroot}%{_sysconfdir}/sysconfig
install -m 644 %{SOURCE18} %{buildroot}%{_sysconfdir}/sysconfig/cups
rm -f %{buildroot}%{_sysconfdir}/init.d/cups

# Install PPDs
mkdir -p %{buildroot}%{_datadir}/cups/model
#install -m 755 ppd/*.ppd %{buildroot}%{_datadir}/cups/model

# RPM breaking it. Links need to be deleted and afterwards regenerated
rm -f %{buildroot}%{_mandir}/man8/cupsdisable.8
rm -f %{buildroot}%{_mandir}/man8/reject.8

# Install script for automatic CUPS configuration
cp %{SOURCE17} %{buildroot}%{_sbindir}/correctcupsconfig
chmod a+rx %{buildroot}%{_sbindir}/correctcupsconfig

# Set compatibility links for the man pages and executables
ln -s %{_sbindir}/cupsenable %{buildroot}%{_bindir}/enable
ln -s %{_sbindir}/cupsdisable %{buildroot}%{_bindir}/disable
ln -s %{_sbindir}/cupsenable %{buildroot}%{_sbindir}/enable
ln -s %{_sbindir}/cupsdisable %{buildroot}%{_sbindir}/disable
ln -s %{_mandir}/man8/cupsenable.8 %{buildroot}%{_mandir}/man8/cupsdisable.8
ln -s %{_mandir}/man8/cupsdisable.8 %{buildroot}%{_mandir}/man8/disable.8
ln -s %{_mandir}/man8/cupsenable.8 %{buildroot}%{_mandir}/man8/enable.8
ln -s %{_mandir}/man8/accept.8 %{buildroot}%{_mandir}/man8/reject.8

%ifarch x86_64
# This one will be removed soon, when all other packages are
# modified appropriately
ln -s %{_prefix}/lib/cups %{buildroot}%{_libdir}/cups
%endif

# prepare the commands conflicting with LPD for the update-alternatives
# treatment
( cd %{buildroot}%{_bindir}
  mv lpr lpr-cups
  mv lpq lpq-cups
  mv lprm lprm-cups
  mv lp lp-cups
  mv cancel cancel-cups
  mv lpstat lpstat-cups
)
( cd %{buildroot}%{_sbindir}
  mv accept accept-cups
  mv disable disable-cups
  mv enable enable-cups
  mv lpc lpc-cups
  mv lpmove lpmove-cups
  mv reject reject-cups
)
( cd %{buildroot}%{_mandir}/man1
  mv lpr.1 lpr-cups.1
  mv lpq.1 lpq-cups.1
  mv lprm.1 lprm-cups.1
  mv lp.1 lp-cups.1
  mv cancel.1 cancel-cups.1
  mv lpstat.1 lpstat-cups.1
)
( cd %{buildroot}%{_mandir}/man8
  mv accept.8 accept-cups.8
  mv disable.8 disable-cups.8
  mv enable.8 enable-cups.8
  mv lpc.8 lpc-cups.8
  mv lpmove.8 lpmove-cups.8
  mv reject.8 reject-cups.8
)
ln -sf %{_sbindir}/accept-cups %{buildroot}%{_sbindir}/reject-cups
ln -sf %{_sbindir}/accept-cups %{buildroot}%{_sbindir}/cupsdisable
ln -sf %{_sbindir}/accept-cups %{buildroot}%{_sbindir}/cupsenable

# Remove links to the startup script, we make our own ones with chkconfig
rm -rf %{buildroot}%{_sysconfdir}/rc?.d/[SK]*
# Remove superflouus man page stuff
rm -rf %{buildroot}%{_mandir}/cat
rm -rf %{buildroot}%{_mandir}/cat?
rm -rf %{buildroot}%{_mandir}/*/cat
rm -rf %{buildroot}%{_mandir}/*/cat?

# Install missing headers (Thanks to Oden Eriksson)
install -m644 cups/debug-private.h  %{buildroot}%{_includedir}/cups/
install -m644 cups/string-private.h %{buildroot}%{_includedir}/cups/
install -m644 config.h %{buildroot}%{_includedir}/cups/

mkdir -p %{buildroot}%{_unitdir}
install -p -m 644 %{SOURCE3} %{buildroot}%{_unitdir}
install -p -m 644 %{SOURCE4} %{buildroot}%{_unitdir}

#Install NCP
install -p -m 755 %{SOURCE7} %{buildroot}%{_prefix}/lib/cups/backend/ncp

# Multiarch fixes
%multiarch_includes %{buildroot}%{_includedir}/cups/config.h

# Create dummy config files /etc/cups/printers.conf,
# /etc/cups/classes.conf, and /etc/cups/client.conf
touch %{buildroot}%{_sysconfdir}/cups/printers.conf
touch %{buildroot}%{_sysconfdir}/cups/classes.conf
touch %{buildroot}%{_sysconfdir}/cups/client.conf

# install /usr/lib/tmpfiles.d/cups.conf (bug #656566, bug #893834)
mkdir -p %{buildroot}%{_tmpfilesdir}
cat > %{buildroot}%{_tmpfilesdir}/cups.conf <<EOF
# See tmpfiles.d(5) for details

d /run/cups 0755 root lp -
d /run/cups/certs 0511 lp sys -

d /var/spool/cups/tmp - - - 30d
EOF

# /usr/lib/tmpfiles.d/cups-lp.conf (bug #812641)
cat > %{buildroot}%{_tmpfilesdir}/cups-lp.conf <<EOF
# Legacy parallel port character device nodes, to trigger the
# auto-loading of the kernel module on access.
#
# See tmpfiles.d(5) for details

c /dev/lp0 0660 root lp - 6:0
c /dev/lp1 0660 root lp - 6:1
c /dev/lp2 0660 root lp - 6:2
c /dev/lp3 0660 root lp - 6:3
EOF

# Prefer xdg-utils than htmlview (kde one)
sed -i s/htmlview/xdg-open/ %{buildroot}%{_datadir}/applications/*.desktop

## Hide desktop file
chmod 0644 %{buildroot}%{_datadir}/applications/cups.desktop
echo -e '\nHidden=true' >> %{buildroot}%{_datadir}/applications/cups.desktop

# http://qa.mandriva.com/show_bug.cgi?id=28383
# Common PPD dirs
mkdir -p %{buildroot}%{_datadir}/ppd

# Make CUPS know them
ln -s /usr/local/share/ppd %{buildroot}%{_datadir}/cups/model/1-local-admin
ln -s /opt/share/ppd %{buildroot}%{_datadir}/cups/model/2-third-party
ln -s %{_datadir}/ppd %{buildroot}%{_datadir}/cups/model/3-distribution

# Common printer driver dirs
mkdir -p %{buildroot}%{_libdir}/printdriver
# Other dirs can't be handled here, but on %post instead.

# Create /dev/lp* nodes to make usblp happy
mkdir -p %{buildroot}%{_sysconfdir}/udev/rules.d
install -c -m 644 %{SOURCE19} %{buildroot}%{_sysconfdir}/udev/rules.d/
# Fix USB printers permissions and groups
install -c -m 644 %{SOURCE20} %{buildroot}%{_sysconfdir}/udev/rules.d/

# Remove stuff that's also in cups-filters
rm -f %{buildroot}%{_datadir}/cups/banners/{classified,confidential,secret,standard,topsecret,unclassified}
rm -f %{buildroot}%{_datadir}/cups/data/testprint

for lang in `ls -1 %{buildroot}%{_datadir}/locale/`
do
    echo "%%lang($lang) %{_datadir}/locale/$lang/cups_$lang.po" >> %{name}.lang
done

%if !%{with bootstrap} && %{enable_check}
%check
export LC_ALL=C
export LC_MESSAGES=C
export LANG=C
export LANGUAGE=C
make test << EOF

EOF
%endif

%changelog

* Sat Aug 05 2017 Vladimir Potapov <vladimir.potapov@rosalab.ru> 1.7.5-18
- (045d841) add CVE-2015-1158, CVE-2015-1159 patch

* Wed May 10 2017 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1.7.5-17
- (411f1cf) Define _tmpfilesdir for older distro releases
- (Denis Silakov: bd82146) Added pkgconfig(libsystemd-daemon) BR
- (Denis Silakov: a0c6b8e) Fix build
- (Denis Silakov: 8b2b1ff) Drop killmode patch

* Fri Jun 26 2015 din (Dmitry Fedorov) <d.fedorov@ntcit-rosa.ru> 1.7.5-16
- (49e770c) Unset PerPageLabels by default; fix segfault in pstops #bz5842

* Tue Jun 16 2015 Denis Silakov <denis.silakov@rosalab.ru> 1.7.5-15
- (28b2632) Added udev rule for Canon (http://bugs.rosalinux.ru/show_bug.cgi?id=5781)

* Mon Jun 08 2015 din (Dmitry Fedorov) <d.fedorov@ntcit-rosa.ru> 1.7.5-14
- (d3fd503) fix patch name
- (din (Dmitry Fedorov): b0b3ae4) Bump release

* Mon Jun 08 2015 din (Dmitry Fedorov) <d.fedorov@ntcit-rosa.ru> 1.7.5-13
- (0efbb44) cleanup mandatory patchset

* Thu Jun 04 2015 Dmitry Fedorov <d.fedorov@ntcit-rosa.ru> 1.7.5-12
- (040813a) fix if statement
- (Dmitry Fedorov: ac282dd) rework mandatory patcheset

* Mon May 18 2015 Dmitry Fedorov <d.fedorov@ntcit-rosa.ru> 1.7.5-11
- (d8e57e5) BuildList#2501564: Increase release tag

* Fri May 15 2015 Denis Silakov <denis.silakov@rosalab.ru> 1.7.5-10
- (f8eafa2) BuildList#2501564: Increase release tag

* Fri May 15 2015 Dmitry Fedorov <d.fedorov@ntcit-rosa.ru> 1.7.5-9
- (61e0849) BuildList#2501564: Increase release tag

* Fri May 15 2015 Dmitry Fedorov <d.fedorov@ntcit-rosa.ru> 1.7.5-8
- (914d18e) BuildList#2501564: Increase release tag

* Wed Apr 22 2015 Denis Silakov <denis.silakov@rosalab.ru> 1.7.5-7
- (587daf0) Rebuild with new poppler

* Sun Feb 22 2015 Alexander Lakhin <a.lahin@ntcit-rosa.ru> 1.7.5-6
- (394dcd3) MassBuild#656: Increase release tag

* Wed Feb 18 2015 Denis Silakov <denis.silakov@rosalab.ru> 1.7.5-5
- (3ae93c7) Do not package /var/run/cups/certs - it is created by systemd automatically now

* Wed Feb 18 2015 kuzma kazygashev <kuzma.kazygashev@rosalab.ru> 1.7.5-4
- (b66f897) Added security fix for CVE-2014-9679.

* Fri Feb 13 2015 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1.7.5-3
- (f21b8e1) Adjust reverted patches order
- (Andrey Bondrov: cc5ad6b) Replace old lspp patches with new versions
- (Andrey Bondrov: 0ea8fcf) Merge remote-tracking branch 'current/current' into rosa2014.1
- (Andrey Bondrov: 39412c2) Add conditions for selinux/lspp support

* Fri Feb 13 2015 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1.7.5-1
- (03a8477) Add markup patches (don't apply yet)

* Fri Feb 13 2015 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1.7.5-2
- (ac1aa99) Drop unused patches

* Fri Feb 13 2015 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1.7.5-1
- (d65783d) Drop unused patch

* Mon Dec 15 2014 din (Dmitry Fedorov) <d.fedorov@ntcit-rosa.ru> 1.7.5-2
- (6fac858) Bump release

* Mon Dec 15 2014 din (Dmitry Fedorov) <d.fedorov@ntcit-rosa.ru> 1.7.5-1
- (64bb881) fix requires
- (din (Dmitry Fedorov): 7a92e54) fix BR
- (din (Dmitry Fedorov): a6c0e38) bootstrap build
- (din (Dmitry Fedorov): f5e9ff1) Selinux patchset transition

* Wed Dec 10 2014 din (Dmitry Fedorov) <d.fedorov@ntcit-rosa.ru> 1.4.8-24.1
- (3ebb814) Build without selinux while new kernel and libselinux not available
- (Andrey Bondrov: 4ef3248) Adjust BuildRequires a bit

* Wed Nov 19 2014 Dmitry Fedorov <d.fedorov@ntcit-rosa.ru> 1.4.8-24
- (19cb220) BuildList#2335087: Increase release tag

* Wed Nov 05 2014 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1.7.5-1
- (322e3ec) Update BuildRequires
- (Andrey Bondrov: 2f21b1d) New version 1.7.5
- (Andrey Bondrov: 2f21b1d) Fix debug package
- (Andrey Bondrov: 2f21b1d) Spec cleanup

* Sat Oct 25 2014 Dmitry Fedorov <d.fedorov@ntcit-rosa.ru> 1.4.8-23
- (53c8841) BuildList#2320919: Increase release tag

* Thu Oct 02 2014 Dmitry Fedorov <d.fedorov@ntcit-rosa.ru> 1.4.8-22
- (83507f7) BuildList#2274925: Increase release tag

* Fri Sep 26 2014 Dmitry Fedorov <d.fedorov@ntcit-rosa.ru> 1.4.8-21
- (62592cd) fix BR
- (Dmitry Fedorov: 4720cc7) MassBuild#518: Increase release tag

* Tue Aug 12 2014 Alex Burmashev <alex.burmashev@rosalab.ru> 1.4.8-20
- (3b784a3) MassBuild#472: Increase release tag

* Tue Aug 12 2014 Alex Burmashev <alex.burmashev@gmail.com> 1.4.8-19.2
- (36235e0) sync to certified branch, 12.08.2014

* Mon Jul 21 2014 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1.7.3-2
- (ef8a128) BuildList#2062192: Increase release tag

* Fri Jul 18 2014 Alex Burmashev <alex.burmashev@rosalab.ru> 1.4.8-21
- (98aef30) MassBuild#456: Increase release tag

* Mon Jul 14 2014 Alex Burmashev <alex.burmashev@rosalab.ru> 1.4.8-20
- (6c1768e) MassBuild#454: Increase release tag

* Fri Jul 11 2014 Denis Silakov <denis.silakov@rosalab.ru> 1.7.3-1
- (6c63faa) Updated to 1.7.3

* Thu Jul 10 2014 Alex Burmashev <alex.burmashev@rosalab.ru> 1.4.8-19
- (9e96cb8) MassBuild#450: Increase release tag

* Tue Jul 01 2014 Alex Burmashev <alex.burmashev@gmail.com> 1.4.8-18.2
- (41ed4be) sync to certified branch

* Fri Jun 27 2014 Alex Burmashev <alex.burmashev@rosalab.ru> 1.7.1-3
- (2cd7ba0) MassBuild#440: Increase release tag

* Thu Oct 31 2013 Alex Burmashev <alex.burmashev@rosalab.ru> 1.4.8-14.2
- (313271a) fixed more requires

* Thu Oct 31 2013 Alex Burmashev <alex.burmashev@rosalab.ru> 1.4.8-13.2
- (d9bc367) fixed requires

* Wed Oct 30 2013 Alex Burmashev <alex.burmashev@rosalab.ru> 1.4.8-12.2
- (2c24c26) changed BR

* Wed Apr 17 2013 Danila Leontiev <danila.leontiev@rosalab.ru> 1.4.8-11.2
- (733d35c) Return back

* Wed Apr 17 2013 Danila Leontiev <danila.leontiev@rosalab.ru> 1.4.8-12.2
- (1990d76) Security fix

* Mon Dec 24 2012 Ilya Porvin <ilya.porvin@rosalab.ru> 1.4.8-11.2
- (750fe27) apply fix patch for CVE-2012-5519

* Fri Dec 14 2012 alexander barakin (aka sash-kan) <alex@barak.in> 1.4.8-10
- (018eb6f) LOG start after portreserve.service; bug #880
- (018eb6f) Signed-off-by: alexander barakin (aka sash-kan) <alex@barak.in>

* Fri Dec 14 2012 alexander barakin (aka sash-kan) <alex@barak.in> 1.4.8-9
- (97c57b7) misspelling
- (97c57b7) Signed-off-by: alexander barakin (aka sash-kan) <alex@barak.in>


